/*
    fcdel.c 1.32

    Usage: fcdel [-F][-S][-C][-D][-Q][-K] <file1> [<file2>|<path>]

*/

#define DOS

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dos.h>

#define HEX 16
#define MAX_FILENAME 260
#define DRIVELETTER 3
#define CMPSIZE 1024*16
#define TARGET 0
#define BASIS 1
#define TRUENAME 0x60
#define LFN2SFN 1
#define SFN2LFN 2

#ifndef _A_NORMAL
#define _A_NORMAL 0
#endif

#ifdef TURBO_C
#define _dos_setfileattr(x,y) chmod(x,y)
#endif

#ifndef NDEBUG
#define unlink(x) 1
#endif

#define issjis(c) ((0x81 <= (c) && (c) <= 0x9f)||(0xe0 <= (c) && (c) <= 0xfc))

static char copyright[]="fcdel version 1.32 Copyright (C) 1995-2011 by Toshiki.N";

#define OPT_SWITCH (1)   /* XCb`^  \LF /TEST  il 1/0  intj*/

typedef struct {

    char *key;  /* IvVw肷ۂ̃L[  F/UMB Ȃ "UMB" Ə */
    int   typ;  /* IvV̌^                                           */
    void *ptr;  /* IvV̒li[AhX                         */
    char *val;  /* ftHgliKŎw肷j                     */

} opt_descript;

struct { /* IvV̒li[\ */

    int   s_flag;
    int   f_flag;
    int   c_flag;
    int   d_flag;
    int   q_flag;
    int   k_flag;

} opt;

FILE *dspout;

char *strright(char *dist, const char *source, const int len) {

    int i;

    if (len <= 0 || strlen(source) < len)
        dist[ 0 ] = '\0';
    else{
        for (i = 0; i < len; i++)
            dist[ i ] = source[ strlen(source) - len + i ];
        dist[ len ] = '\0';
    }
    return dist;
}

char *zero_padding(unsigned long data, int len, char *tmp) {

    char zero[20] = "0000000000";  /* őX܂strcat\ */

    return strright(tmp, strcat(zero, ultoa(data, tmp, HEX)), len);
}

char *extract_path(char *full_path) {

    int i;
    
    if (full_path[strlen(full_path)-1]=='\\') {
        full_path[strlen(full_path)-1]='\0';
    }
    i = strlen(full_path) - 1;
    while (i > 0 && full_path[i] != '\\') {
        full_path[i] = '\0';
        i--;
    }
    return full_path;
}

void usage () {
    fputs(copyright, stderr);
    fputs("\nUsage: ", stderr);
    fputs("fcdel", stderr);
    fputs(" [-F][-S][-C][-D][-Q][-K] <file1> [<file2>|<path>]\n", stderr);
    exit(EXIT_FAILURE);
}

void open_err(char *filename) {
    fputs("Can't open ", dspout);
    fputs(filename, dspout);
    fputs("\n", dspout);
}

void close_err(char *filename) {
    fputs("Can't close ", dspout);
    fputs(filename, dspout);
    fputs("\n", dspout);
}

void start_message(char *str1, char *str2) {
    fputs("Comparing ", dspout);
    fputs(str1, dspout);
    fputs(" to ", dspout);
    fputs(str2, dspout);
    fputs("\n", dspout);
}

void mismatch(unsigned long location, int data1, int data2) {

    char tmp[32];

    fputs("Mismatch! First mismatch location at\n", dspout);
    fputs(zero_padding(location, 8, tmp), dspout);
    fputs(":", dspout);
    fputs(zero_padding(data1, 2, tmp), dspout);
    fputs(" ", dspout);
    fputs(zero_padding(data2, 2, tmp), dspout);
    fputs("\n", dspout);
}

int parse_arg(int argc, char **argv, char fname[2][MAX_FILENAME], opt_descript *desc) {
    int      argn = argc;   /* argv ̌                                  */
    char   **argp = ++argv; /* argv 𑖍|C^[iargv[0]  skipj */
    char    *arg;           /* IvṼL[ȉw|C^[         */
    int      i, l;

    /* default l̐ݒ */
    for (i = 0; desc[i].key; i++) {
            *((int *)(desc[i].ptr)) = atoi(desc[i].val);
    }

    /* argv ̑ */
    for (--argn; argn > 0; --argn, ++argp) {
        /* Pڂ '/'  '-' ȂIvVƌ */
        if (**argp == '/' || **argp == '-') {
        /* Ή OptDesc ̌ */
            for (i = 0; desc[i].key; i++) {
                l = strlen(desc[i].key);
                if (!strncmp(&((*argp)[1]), desc[i].key, l)) break;
            }
            /* OptDesc Ȃ */
            if (!(desc[i].key)) {
                fputs("Unknown Option\n", stderr);
                usage();
            }

            /* arg ̃ZbgF؂蕶̃`FbN */
            arg = &((*argp)[l + 1]);
            if (*arg != ((desc[i].typ == OPT_SWITCH) ? ('\0') : ('='))) {
                fputs("invalid option : ", stderr);
                fputs(desc[i].key, stderr);
                fputs("\n", stderr);
                usage();
            }
            /* arg ͒lw悤ɂȂ */
            arg++;
        
            *((int *)(desc[i].ptr)) = !(*((int*)(desc[i].ptr)));
        
        } else { /* file w肾ꍇ */
            strcpy(*fname, *argp);
            fname++;
        }
    }
}

int perfect_name(char *buf, int mode) {
#ifdef DOS
    union  REGS  inregs, outregs;
    struct SREGS segregs;
    int ax;

    segread(&segregs);
    segregs.ds  = segregs.es  = FP_SEG(buf);
    inregs.x.si = inregs.x.di = FP_OFF(buf);
    inregs.x.ax = 0x7100 + TRUENAME;
    inregs.x.cx = mode;
    ax = intdosx(&inregs, &outregs, &segregs);
    if (outregs.x.cflag != 0 || ax == 0x7100) {
        segread(&segregs);
        segregs.ds  = segregs.es  = FP_SEG(buf);
        inregs.x.si = inregs.x.di = FP_OFF(buf);
        inregs.h.ah = TRUENAME;
        inregs.h.al = 0x00;
        intdosx(&inregs, &outregs, &segregs);
    }
#endif
}

FILE *fileopen(char *filename, char *mode) {

    char fname[MAX_FILENAME];
    FILE *tmp;
    
    tmp = fopen(filename, mode);
#ifdef DOS
    if (tmp == NULL) {
        strcpy(fname, filename);
        perfect_name(fname, LFN2SFN);
        tmp = fopen(fname, mode);
    }
#endif
    return tmp;
}

unsigned filesetattr(char *path, unsigned attr) {

    char p[MAX_FILENAME];
    unsigned tmp;
    
#ifdef DOS
    tmp = _dos_setfileattr(path, attr);
    if (tmp != 0) {
        strcpy(p, path);
        perfect_name(p, LFN2SFN);
        tmp = _dos_setfileattr(p, attr);
    }
#endif
    return tmp;
}

unsigned filedelete(char *path) {

    char p[MAX_FILENAME];
    unsigned tmp;
    
    tmp = unlink(path);
#ifdef DOS
    if (tmp != 0) {
        strcpy(p, path);
        perfect_name(p, LFN2SFN);
        tmp = unlink(p);
    }
#endif
    return tmp;
}

int filestat(char *path, struct stat *sbuf) {

    char p[MAX_FILENAME];
    int tmp;
    
    tmp = stat(path, sbuf);
#ifdef DOS
    if (tmp != 0) {
        strcpy(p, path);
        perfect_name(p, LFN2SFN);
        tmp = stat(p, sbuf);
    }
#endif
    return tmp;
}

void construct_2ndfilename(char name[2][MAX_FILENAME]) {

    int i, l, pt = 0;
    char c;
    struct stat f;

    if (strlen(name[BASIS]) == 0) {
        name[BASIS][0] = '.';
        name[BASIS][1] = '/';
        name[BASIS][2] = '\0';
    }

    l = strlen(name[BASIS]);
    c = name[BASIS][l - 1];
    filestat(name[BASIS], &f);
    if (((c != ':' && c != '\\' && c != '/' && ((f.st_mode & S_IFMT) == S_IFDIR))) || c == '.') {
            name[BASIS][l  ] = '\\';
            name[BASIS][l + 1] = '\0';
    }

    c = name[BASIS][strlen(name[BASIS]) - 1];
    if (c == ':' || c == '\\' || c == '/') {
        for (i = 0; i < strlen(name[TARGET]); i++) {
            if (issjis((int) name[TARGET][i])) {
                i++;
            }else if (name[TARGET][i] == '/' || name[TARGET][i] == '\\' || name[TARGET][i] == ':') {
                pt = i + 1;
            }
        }
        strcat(name[BASIS], &name[TARGET][pt]);
    }
}

int bin_comp(char name[2][MAX_FILENAME], FILE *fp[2]) {

    int i, j;
    unsigned long count;
    static char tmp1[CMPSIZE], tmp2[CMPSIZE];
    struct stat buf1, buf2;

    filestat(name[TARGET], &buf1);
    filestat(name[BASIS], &buf2);
    if ((buf1.st_size < buf2.st_size) && !opt.s_flag) {
        fputs(name[TARGET], dspout);
        fputs(" is shorter\n", dspout);
        exit(EXIT_FAILURE);
    }else if (buf1.st_size > buf2.st_size) {
        fputs(name[TARGET], dspout);
        fputs(" is longer\n", dspout);
        exit(EXIT_FAILURE);
    }
    for (count = 0; count <= buf1.st_size; count += CMPSIZE) {
        i = fread(tmp1, 1, CMPSIZE, fp[TARGET]);
        j = fread(tmp2, 1, CMPSIZE, fp[BASIS]);
        if ((i != j) || memcmp(tmp1, tmp2, CMPSIZE)) {
            for (i = 0; tmp1[i] == tmp2[i]; i++);
            if (count + i >= buf1.st_size) break;
            mismatch(count + i, tmp1[i], tmp2[i]);
            exit(EXIT_FAILURE);
        }
    }
}

int os_chk(void) {
    if (_osmajor < 3) {
        fputs("Error : illegal DOS version\n", dspout);
        exit(EXIT_FAILURE);
    }
}

int delete_empty_dir(char *dir_name) {

    int result;
    char tmp[128];
  
    result = 0;
    if (dir_name[strlen(dir_name)-1]=='\\') {
        dir_name[strlen(dir_name)-1]='\0';
    }
    while (access(dir_name, 0) == 0 && strlen(dir_name) > 3) {
        strcpy(tmp,dir_name);
        strcat(tmp,"\\..");
        chdir(tmp);
        if (rmdir(dir_name) == 0) {
            fputs(dir_name, dspout);
            fputs(" : Deleted.\n", dspout);
            result++;
            dir_name = extract_path(dir_name);
        } else {
            break;
        }
        if (dir_name[strlen(dir_name)-1]=='\\') {
            dir_name[strlen(dir_name)-1]='\0';
        }
    }
    return result;
}

int main(int argc, char **argv) {

    int i;
    char fname[2][MAX_FILENAME];
    char commandline[2][MAX_FILENAME];
    FILE *fp[2];
    opt_descript option[] = {
        { "S", OPT_SWITCH, &opt.s_flag, "0" },
        { "F", OPT_SWITCH, &opt.f_flag, "0" },
        { "C", OPT_SWITCH, &opt.c_flag, "0" },
        { "D", OPT_SWITCH, &opt.d_flag, "0" },
        { "Q", OPT_SWITCH, &opt.q_flag, "0" },
        { "K", OPT_SWITCH, &opt.k_flag, "0" },
        NULL
    };

    os_chk();

    strcpy(commandline[TARGET], "");
    strcpy(commandline[BASIS], "");
    if (argc < 2) usage();
    parse_arg(argc, argv, commandline, option);
    if (opt.q_flag) {
        dspout = NULL;
    } else {
        dspout = stdout;
    }

    if (strlen(commandline[TARGET]) == 0) usage();
    construct_2ndfilename(commandline);
    strcpy(fname[TARGET], commandline[TARGET]);
    strcpy(fname[BASIS], commandline[BASIS]);
    perfect_name(fname[TARGET], SFN2LFN);
    perfect_name(fname[BASIS], SFN2LFN);

    if (!strcmp(fname[TARGET], fname[BASIS])) {
        fputs("Error : same path comparison\n", dspout);
        exit(EXIT_FAILURE);
    }
    
    start_message(fname[TARGET], fname[BASIS]);

    for (i = TARGET; i <= BASIS; i++) {
        if ((fp[i] = fileopen(commandline[i], "rb")) == NULL) {
            open_err(fname[i]);
            exit(EXIT_FAILURE);
        }
    }

    bin_comp(fname, fp);

    fputs("Match!\n", dspout);
    for (i = TARGET; i <= BASIS; i++) {
        if ((fclose(fp[i])) == EOF) {
            close_err(fname[i]);
            exit(EXIT_FAILURE);
        }
    }
    if (opt.c_flag) return 0;
    if (opt.k_flag) {
        fputs("Hit Return to Delete ", dspout);
        fputs(fname[TARGET], dspout);
        getchar();
    }
    fputs(fname[TARGET], dspout);
    if (opt.f_flag) filesetattr(commandline[TARGET], _A_NORMAL);
    if (!filedelete(commandline[TARGET])) {
        fputs(" : Deleted.\n", dspout);
        if (opt.d_flag) {
            delete_empty_dir(extract_path(commandline[TARGET]));
        }
    }else{
        fputs(" : Delete unsuccessful, sorry!\n", dspout);
        return EXIT_FAILURE;
    }
    return EXIT_SUCCESS;
}
